// MSetarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MSetar.h"
#include "MSetarDlg.h"
#include "ParGenAlgDlg.h"
#include "ParMSetarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include "sga.h" 
#include "math.h"
#include "AllDinamica.h"


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSetarDlg dialog

CMSetarDlg::CMSetarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSetarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMSetarDlg)
	m_print_gen = _T("");
	m_Print_Repli = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMSetarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMSetarDlg)
	DDX_Text(pDX, IDC_PRINT_GENERATION, m_print_gen);
	DDX_Text(pDX, IDC_PRINT_REPLI, m_Print_Repli);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMSetarDlg, CDialog)
	//{{AFX_MSG_MAP(CMSetarDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PAR_GA, OnParGa)
	ON_BN_CLICKED(IDOK, OnMainProgram)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSetarDlg message handlers

BOOL CMSetarDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMSetarDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMSetarDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMSetarDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMSetarDlg::OnParGa() {

	CParGenAlgDlg objectGA;
	objectGA.m_P_Crossover=0.9;
	objectGA.m_P_Mutation=0.001;
	objectGA.m_Size_Pop=50;
	objectGA.m_N_Generation=100;
	objectGA.m_Constant_Linear =1.2;
	objectGA.m_osservazioni = 1000;
	objectGA.m_componenti =4;
	objectGA.m_spam = 50;
	objectGA.m_PERFILE = "TassidiCambio.txt";
	objectGA.m_maxorder =2;
	
	objectGA.DoModal();
	UpdateData();

	nosservazioni = objectGA.m_osservazioni;
	ncomponenti = objectGA.m_componenti;
	percorso_file = objectGA.m_PERFILE;
	minoss = objectGA.m_spam;
	max_order_var = objectGA.m_maxorder;

	n_of_gen = objectGA.m_N_Generation;
	prob_cros = objectGA.m_P_Crossover;
	prob_mut = objectGA.m_P_Mutation;
	n_crom = objectGA.m_Size_Pop;
	t_selection = objectGA.m_nRouletteWheelm;
	size_tour =  objectGA.m_SizeTournament;
	t_cros = objectGA.m_nOnePointCrossover;
	t_scaling = objectGA.m_nLinearOption;
	value_cost_lin = objectGA.m_Constant_Linear;
	value_beta = objectGA.m_ConstantBeta;
	value_sigma_trunc= objectGA.m_constantST;
	value_scaling_window = objectGA.m_ConstantWindow;



  
}

void CMSetarDlg::OnMainProgram() {

	int i, j, flag_1;

    // Inizializzazione delle variabili globali
	number_oss = nosservazioni;
	number_comp = ncomponenti;
	oss_min = minoss;
	order_VAR=max_order_var;


	mainP();
	

} // close main program


void CMSetarDlg::mainP(void) {


	struct individual *temp;
	int i,j;
	FILE *qfPtr;
	int n_oss_delete;

	if((outfp = fopen ("Output.txt", "w")) ==NULL) printf("ciao\n");
	
	if((infp=  fopen("inputonepop2.txt", "r"))==NULL)  printf("File inputonepop2.txt could not be opened\n");


	// *********************** Stabiliamo alcuni parametri ***********************************
    
	// Parametri che non cambiano mai nel GA con una sola popolazione
	many = 0;
	interactive=0;
	extending =0;
    single_process = TRUE;
    startgen = 0;       // initial generation number for non-restart runs 
	quiet = 0;
    gen = 0;
	maxruns = 1;
	permproblem = 0;
	pinversion = 0.0;
	printstrings = 1;


	/* Scelta del tipo di codifica: si sceglie il valore di alpha_size e di numfields:
	   alpha_size =2 ---> Codifica binaria
	   alpha_size >2 ---> Codifica Intera con stesso range
	   alpha_size <2 ---> Codifica Intera con differente range, bisogna fissare field_sizes[] 

       numfields rappresenta la lunghezza della stringa
	*/
	alpha_size = -1;
	numfields = 16;

	// Opzione sull'utilizzo dell'inizializzazione super uniforme VALE SOLO PER CODIFICA BINARIA
	superuniform_initialization =FALSE;


    // Prendo i valori dalle finestre di dialogo
	UpdateData(true);

	// Parametri Algoritmo Genetico
	maxgen = n_of_gen;
	popsize = n_crom;
	pcross = prob_cros;
	pmutation = prob_mut;
	tourneysize = size_tour;

	// Operatore Selezione
	if(t_selection ==0) type_selection=1;
	if(t_selection ==1) type_selection=4;
	if(t_selection ==2) type_selection=3;
	if(t_selection ==3) type_selection=2;
	
	// Operatore Crossover
	if(t_cros==0) type_crossover=0;
	if(t_cros==1) type_crossover=1;
	if(t_cros==2) type_crossover=2;

	// Operatori Mutazione e Inversione
	type_mutation=0;
	type_inversion=0;

	if(type_selection==0) which_selection= "rnkslect.c";
    if(type_selection==1) which_selection= "rselect.c";
    if(type_selection==2) which_selection= "suselect.c";
    if(type_selection==3) which_selection= "tselect.c";
    if(type_selection==4) which_selection= "stochastic_remainder";
		
	if(type_mutation==0) which_mutation= "bitmutat";
	if(type_mutation==1) which_mutation= "multimut";
    if(type_mutation==2) which_mutation= "scramble";
    if(type_mutation==3) which_mutation= "swap";
	if(type_mutation==4) which_mutation= "user_mutation";


	if(type_crossover==0) which_crossover= "oneptx.c";
	if(type_crossover==1) which_crossover= "twoptx.c";
    if(type_crossover==2) which_crossover= "unifx.c";
    if(type_crossover==3) which_crossover= "cx.c";
    if(type_crossover==4) which_crossover= "uobx.c";
	if(type_crossover==5) which_crossover= "pmx.c";
	if(type_crossover==6) which_crossover= "ox.c";
	if(type_crossover==7) which_crossover= "user_cros";

	if(type_inversion==0) which_inversion= "standard";
	else                  which_inversion= "circular"; 

	fprintf(outfp, "MaxGen =%d\n",maxgen);
	fprintf(outfp, "popsize =%d\n",popsize);
	fprintf(outfp, "pcross =%.3f\n",pcross);
	fprintf(outfp, "pmutation =%.3f\n",pmutation);
	fprintf(outfp, "Type Crossover =%s\n",which_crossover);
	fprintf(outfp, "Type Mutation =%s\n",which_mutation);
	fprintf(outfp, "Type Selection =%s\n",which_selection);
	

	// Metodi per scalare la fitness
	beta = value_beta;
	sigma_trunc = value_sigma_trunc;
	scaling_window = value_scaling_window;
	scalemult = value_cost_lin;
	fprintf(outfp, "scaling_window =%d\n",scaling_window);
	fprintf(outfp, "scalemult =%.3f\n",scalemult);
	fprintf(outfp, "beta =%.3f\n",beta);
	fprintf(outfp, "sigma_trunc =%.3f\n",sigma_trunc);
	fprintf(outfp, "tourneysize =%d\n",tourneysize);

	// Parametri per il problema della stima di un modello multiSETAR
	fprintf(outfp, "n_oss =%d\n",number_oss);

	// Allocazione memoria per la serie
	serie = dmatrix(1,number_oss, 1, number_comp);

	// Apro il file di testo da cui viene letta la serie d'ingresso 
	/*if ((qfPtr =fopen("TassidiCambio.txt", "r")) == NULL)  printf("File seriesj could not be opened\n");
	for(i=1; i<=number_oss;i++) {
		for(j=1; j<=number_comp; j++) {
			fscanf(qfPtr, "%le", &serie[i][j]);
		}
	}
	fclose(qfPtr);*/


	// Apro il file ".txt" da cui viene letta la serie d'ingresso  
	CString xx = percorso_file;
    if ((qfPtr =fopen(xx, "r")) == NULL) {
		CString str;
		str.Format("File %s could not be opened", xx);
		MessageBox(str, "Error", MB_ICONSTOP);
		exit(EXIT_SUCCESS);
	}
	for(i=1; i<=number_oss;i++) {
		for(j=1; j<=number_comp; j++) {
			fscanf(qfPtr, "%le", &serie[i][j]);
		}
	}
	fclose(qfPtr);



	// ************************** AutoControl ***********************
	if(t_scaling ==2) {
		autocontrol_selection = 1;
		beta_s_tilde = 0.5 * sqrt(2.0 * log((double)popsize));
		scaling_window = -1;
		sigma_trunc =0.0;
		scalemult =0.0;
	}

	// ******************** Bolzman ************************
	if(t_scaling ==1) {
		scaling_window = -1;
		sigma_trunc =0.0;
		autocontrol_selection =0;
		scalemult =0.0;
	}
	if(t_scaling ==1 && beta <0) {
		CString str = "Bolzman constant must be >= 0";
		MessageBox(str, "Error", MB_ICONSTOP);
    	exit(EXIT_SUCCESS);
	}
	

	// ********************Window********************
	if(t_scaling ==4) {
		sigma_trunc =0.0;
		autocontrol_selection =0;
		beta =-1.0;
		scalemult =0.0;
	}
	if(t_scaling ==4 && scaling_window<0) {
		CString str = "Window constant must be >= 0";
		MessageBox(str, "Error", MB_ICONSTOP);
    	exit(EXIT_SUCCESS);
	}

	
	// *************** Sigma Troncation *******************+
	if(t_scaling ==3) {
		autocontrol_selection =0;
		beta =-1.0;
		scalemult =0.0;
		scaling_window = -1;
	}
	if(t_scaling ==3 && sigma_trunc==0) {
		CString str = "Sigma Trouncation constant must be != 0";
		MessageBox(str, "Error", MB_ICONSTOP);
    	exit(EXIT_SUCCESS);
	}

    // **************** Linear ****************************
	if(t_scaling ==0) {
		autocontrol_selection =0;
		scaling_window = -1;
		beta=-1.0;
		sigma_trunc=0.0;
	}
	if(t_scaling ==0 && scalemult <=1.0) {
		CString str = "Constant of Scaling Linear must be > 1";
		MessageBox(str, "Error", MB_ICONSTOP);
    	exit(EXIT_SUCCESS);
	}

	if(t_scaling ==0) fprintf(outfp, "Scaling Method is Linear\n");
	if(t_scaling ==1) fprintf(outfp, "Scaling Method is Bolzman\n");
	if(t_scaling ==2) fprintf(outfp, "Scaling Method is Autocontrol\n");
	if(t_scaling ==3) fprintf(outfp, "Scaling Method is Sigma Troncation\n");
	if(t_scaling ==4) fprintf(outfp, "Scaling Method is Window\n");
	
	fprintf(outfp, "autocontrol_selection =%d\n",autocontrol_selection);



	// *************** Ha inizio il cuore dell'algoritmo genetico *****************

	for(run = 1; run <= maxruns; run++) {  // le volte che eseguo l'algoritmo genetico

		//if(quiet < 3) fprintf(outfp, "\n*** Beginning of run %d ***\n", run);

		// Get configuration inputs for this run 
        GetThisRunInputs();

	    for(gen = startgen; gen < maxgen; gen++) {

			//fprintf(outfp, "********Generation %d ***\n", gen);
            
			m_print_gen.Format("%d", gen); // memorizza l'iterazione nella finestra
			UpdateData(FALSE);

			//if(quiet == 0) fprintf(outfp, "\nRUN %d of %d: GENERATION %d->%d\n", run, maxruns, gen, maxgen);
			
			// application dependent routines 
			application();
		
			// create a new generation 
			generation();


			// compute fitness statistics on new populations 
		    statistics(newpop);
		    windowend++;              // advance window for window scaling 

		    // report results for new generation 
			if(gen==maxgen-1) {
				if(quiet < 3) report();
			}
            
			// zeroes for parameters below used in GALOPPS/Manypops, not Onepop version. 
			//if(quiet > 0) app_quiet_report();

			// advance the generation 
		    temp = oldpop;
		    oldpop = newpop;
		    newpop = temp;

			// Allow user to make changes if population performance or 
		    // convergence measures meet certain user-specified criteria.
		    //ModifyRunBasedOnConvergence();

		} // close loop gen


		// in case didn't run any generations, fix up statistics before write out the checkpoint file.
		if (startgen >= maxgen) {
			statistics(oldpop);
			//remap_then_objfunc(&(bestfit));
		}


	    fflush(outfp);
	    freeall();

 
	} // close loop run: close of GA


	// Libero la memoria
	free_dmatrix(serie ,1,number_oss, 1, number_comp);

    // Chiusura dei file di scrittura
	fclose(outfp);
	fclose(infp);

  

  return;


}



// Query user (or input file) for the parameters which will stay the 
// same over all of the runs requested (one or more). 
void GetThisRunInputs() {

	char  answer;

	// Sostituiamo a GetUniversalInputs() il suo codice
	char c;
	// Initialize problem-specific input parameters to INVALID values 
	ckptfreq = -1;
	local_bestfit.init_fitness = -1.0; // any non-negative fitness will replace 

	// *************************Viene stabilito il valore di quiet *************************

	app_read_prob_params();

	    
	// Now, need following if a perm problem, else no effect 
	if (permproblem == 1) {
		alpha_size = numfields;
	}

	//problem_inputs();

	// Call app_set_options() to let user set conditions for run. 
	app_set_options();


	// Inizializzo alcune variabili globali
    conv_sigma_coeff = 7.0;
    convinterval = 10;
    popno = 0;


	// ************************* Selezione di popsize ************************************************************
		
    if ((popsize % 2)) {
		printf("Sorry! only even population sizes are allowed. \n"); 
		printf("Incrementing popsize by one.\n");
		popsize++;
	}
	if (popsize < 2) {
		printf("Sorry! minimum population size is 2.\n");
		popsize = 2;
	}


	/* Since I agree with Shapiro that automatic selection should use */
    /* Stochastic Universal Sampling, I require that user load suselect.c */
    /* if this automatic option is chosen.  Checked here. */
    if (autocontrol_selection == 1 && type_selection != 2) {
		fprintf (stderr, "OOPS, Automatic control of selection uses ");
		fprintf (stderr, "suselect.c, Stochastic Universal Sampling,\n");
		fprintf (stderr, "and that is not the selection method loaded.\n");
		fprintf (stderr, "Please load that and rerun.");
		exit (-1);
	}
	
    //	app_data(FALSE);            /* flag says INITIALIZING */


	// Set things up 
	initialize();


	// Malloc temporary space needed for permutation-type operators 
	if(permproblem) MallocPermOperSpace();

}


int simMSetar() {


	int i, j, k, l,h, jj;
	long idum = -2.0*number_rep;
	int n, n_comp;
	float **x, **a,*p, sum, **y,*medie, **Sigma;
	int ii, n_regime, n_oss, which_serie, t_d, t, lag_d, order_Var;
	double R[4]={1000000.0,1000000.0,1000000.0,1000000.0}; //  R[]  il vettore delle soglie
	double **AA;
	FILE *outfp2,*fp,*outfp1, *priserPtr;


	n_oss = n_oss_tot;
	n_comp = number_comp;
	n_regime = 2;
	order_Var=order_VAR;
	n= n_oss;
	int n_par=(n_comp*n_comp)*order_Var;


	x=matrix(1,n_comp,1,n);
	a=matrix(1,n_comp,1,n_comp);
	p = vector(1,n_comp);
	y=matrix(1,n_comp,1,n);
	medie= vector(1,n_comp);
	Sigma=matrix(1,n_comp,1,n_comp);
	AA=dmatrix(1,n_par,1,4);

	if ((fp = fopen("matrx1.dat","r")) == NULL) printf("Data file matrx1.dat not found\n");
	//if((outfp2 = fopen ("UrtiFinali.txt", "w")) ==NULL) printf("ciao\n");
	//if((outfp1 = fopen ("UrtiNormali.txt", "w")) ==NULL) printf("ciao\n");
	if((priserPtr = fopen ("SerieSim.txt", "a")) ==NULL) printf("ciao\n");


	// Il vettore AA contiene i parametri del modello. Se n_comp=2 e order_Var=1:
	// AA[1][1] e AA[2][1] costituiscono la prima colonna di Phi1^(1)
	// AA[3][1] e AA[4][1] costituiscono la seconda colonna di Phi1^(1)


	// Stabiliamo i parametri Phi
	AA[1][1] = 0.7; AA[2][1] = 0.3;
	AA[3][1] = 0.0; AA[4][1] = 0.7;

	AA[1][2] = -0.7; AA[2][2] = -0.3;
	AA[3][2] = 0.0; AA[4][2] = -0.7;


	// Stabiliamo le soglie
	R[0]=0.0;


	// Stabiliamo la variabile soglie e il ritardo
	which_serie=1;
	lag_d=1;


	
	for (i=1;i<=n_comp;i++)
			for (j=1;j<=n_comp;j++) fscanf(fp,"%f ",&a[i][j]);

	
			
	// Creazione di una matrice di urti normali con media zero e varianza 1
	for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n; j++) {
			x[i][j] = gasdev(&idum);
		}
		
	}


	// Calcolo della radice quadrata della matrice di varianze e covarianze
	choldc(a,n_comp,p);

	for (l=1;l<=n_comp;l++) a[l][l]=p[l];

	/*
	for (k=1;k<=m;k++) {
		for (l=1;l<=m;l++) {
			a[k][l]= a[l][k];
		}
	}*/

	for (k=1;k<=n_comp;k++) {
		for (l=1;l<=n_comp;l++) {
			if (l > k) {
				a[k][l]=0.0;
			}
		}
	}

	/*for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n_comp; j++) {
			printf("%f\t",a[i][j]);
		}
		printf("\n");
	}*/


	// Calcolo degli urti et = (Sigma)^(1/2)*at
	for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n; j++) {
			sum =0.0;
			for(k=1; k<=n_comp; k++) sum = sum + a[i][k]*x[k][j];
			y[i][j]=sum;
		}
	}

	/*
	for(i=1; i<=n; i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(outfp1,"%f\t",x[j][i]);
		}
		fprintf(outfp1,"\n");
	}*/


	/*
	for(i=1; i<=n; i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(outfp2,"%f\t",y[j][i]);
		}
		fprintf(outfp2,"\n");
	}*/


	//verifica
	// Calcolo delle medie
	for(j=1; j<=n_comp; j++) {
		sum =0.0;
		for(h=1; h<=n; h++) sum = sum + y[j][h];
		medie[j] = sum/(double)n;
		//printf("medie[%d] =%.15f\n", j,medie[j]);
	}


	for(j=1; j<=n_comp; j++) {
		for(i=1; i<=n_comp; i++) {
			sum =0;
			for(h=1; h<=n; h++) {
				sum = sum + (y[j][h]-medie[j])*(y[i][h]-medie[i]);
			}
			Sigma[j][i]=sum/(double)n;
			//printf("sigma[%d][%d] =%.10f\n", j,i,Sigma[j][i]);
		}
	}



	for(j=1; j<=n_comp; j++) {

			for(t=order_Var+1; t<=n_oss;t++){

				t_d= t-lag_d;
				
				if(sim_Var[t_d][which_serie] <= R[0]) { // condizione primo regime
					ii=1;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					//fprintf(priserPtr,"Xt-d:%f\n", sim_Var[t_d][which_serie]);
					sum =0.0;
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);
										

				} // chiusura condizione I regime


				if(sim_Var[t_d][which_serie] > R[0] && sim_Var[t_d][which_serie] <= R[1]) { // condizione secondo regime
					sum =0;
					ii=2;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione II regime


				if(sim_Var[t_d][which_serie] > R[1] && sim_Var[t_d][which_serie] <= R[2]) { // condizione terzo regime
					sum =0;
					ii=3;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione III regime


				if(sim_Var[t_d][which_serie] > R[2]) { // condizione quarto regime
					sum =0.0;
					ii=4;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione III regime

				
				
			} // chiusura loop n_oss
	} // chiusura loop n_comp


	fprintf(priserPtr, "Serie: %d\n", number_rep);
	for(i=1; i<=(n_oss_tot-2*number_oss); i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(priserPtr,"%f\t",sim_Var[number_oss+i][j]);
		}
		fprintf(priserPtr,"\n");
	}


	// Liberiamo la memoria allocata
	free_matrix(x,1,n_comp,1,n);
	free_matrix(a,1,n_comp,1,n_comp);
	free_vector(p,1,n_comp);
	free_matrix(y,1,n_comp,1,n);
	free_vector(medie,1,n_comp);
	free_matrix(Sigma,1,n_comp,1,n_comp);
	free_dmatrix(AA,1,n_par,1,4);

	//fclose(outfp2);
	fclose(fp);
	//fclose(outfp1);
	fclose(priserPtr);

	return 0;

}



int simMSetar2() {


	int i, j, k, l,h, jj;
	long idum = -2.0*number_rep;
	int n, n_comp;
	float **x, **a,*p, sum, **y,*medie, **Sigma;
	int ii, n_regime, n_oss, which_serie_1, which_serie_2, t_d, t, lag_d, order_Var;
	double R[4]={1000000.0,1000000.0,1000000.0,1000000.0}; //  R[]  il vettore delle soglie
	double **AA;
	FILE *outfp2,*fp,*outfp1, *priserPtr;


	n_oss = n_oss_tot;
	n_comp = number_comp;
	n_regime = 4;
	order_Var=order_VAR;
	n= n_oss;
	int n_par=(n_comp*n_comp)*order_Var;


	x=matrix(1,n_comp,1,n);
	a=matrix(1,n_comp,1,n_comp);
	p = vector(1,n_comp);
	y=matrix(1,n_comp,1,n);
	medie= vector(1,n_comp);
	Sigma=matrix(1,n_comp,1,n_comp);
	AA=dmatrix(1,n_par,1,4);

	if ((fp = fopen("matrx1.dat","r")) == NULL) printf("Data file matrx1.dat not found\n");
	if((outfp2 = fopen ("UrtiFinali.txt", "w")) ==NULL) printf("ciao\n");
	//if((outfp1 = fopen ("UrtiNormali.txt", "w")) ==NULL) printf("ciao\n");
	if((priserPtr = fopen ("SerieSim.txt", "a")) ==NULL) printf("ciao\n");


	// Il vettore AA contiene i parametri del modello. Se n_comp=2 e order_Var=1:
	// AA[1][1] e AA[2][1] costituiscono la prima colonna di Phi1^(1)
	// AA[3][1] e AA[4][1] costituiscono la seconda colonna di Phi1^(1)


	// Stabiliamo i parametri Phi
	AA[1][1] = 0.4; AA[2][1] = 0.3; AA[3][1] = 0.2; AA[4][1] = -0.3;
	AA[5][1] = 0.2; AA[6][1] = -0.5; AA[7][1] = -0.2; AA[8][1] = 0.4;
	AA[9][1] = 0.0; AA[10][1] = 0.3; AA[11][1] = 0.5; AA[12][1] = -0.3;
	AA[13][1] = 0.2; AA[14][1] = -0.2; AA[15][1] = -0.2; AA[16][1] = 0.3;


	AA[1][2] = -0.15; AA[2][2] = 0.3;    AA[3][2] = 0.15; AA[4][2] = -0.3;
	AA[5][2] = 0.15; AA[6][2] = -0.09;    AA[7][2] = -0.15; AA[8][2] = 0.09;
	AA[9][2] = 0.0; AA[10][2] = 0.3;     AA[11][2] = 0.0; AA[12][2] = -0.3;
	AA[13][2] = 0.15; AA[14][2] = -0.06; AA[15][2] = -0.15; AA[16][2] = 0.06;

	AA[1][3] = -0.8; AA[2][3] = -0.3; AA[3][3] = -0.2; AA[4][3] = 0.3;
	AA[5][3] = -0.2; AA[6][3] = 0.8; AA[7][3] = 0.2; AA[8][3] = -0.8;
	AA[9][3] = 0.0; AA[10][3] = -0.3; AA[11][3] = -1.0; AA[12][3] = 0.3;
	AA[13][3] = -0.2; AA[14][3] = 1.2; AA[15][3] = 0.2; AA[16][3] = -0.6;


	AA[1][4] = 0.15; AA[2][4] = -0.3; AA[3][4] = -0.15; AA[4][4] = 0.3;
	AA[5][4] = -0.15; AA[6][4] = 0.09; AA[7][4] = 0.15; AA[8][4] = -0.09;
	AA[9][4] = 0.0; AA[10][4] = -0.3; AA[11][4] = 0.0; AA[12][4] = 0.3;
	AA[13][4] = -0.2; AA[14][4] = 0.06; AA[15][4] = 0.15; AA[16][4] = -0.06;




	// Stabiliamo le soglie
	R[0]=0.0;
	R[1]=0.0;


	// Stabiliamo la variabile soglie e il ritardo
	which_serie_1=1;
	which_serie_2=2;
	lag_d=1;

	
	for (i=1;i<=n_comp;i++)
			for (j=1;j<=n_comp;j++) fscanf(fp,"%f ",&a[i][j]);

	
			
	// Creazione di una matrice di urti normali con media zero e varianza 1
	for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n; j++) {
			x[i][j] = gasdev(&idum);
		}
		
	}


	// Calcolo della radice quadrata della matrice di varianze e covarianze
	choldc(a,n_comp,p);

	for (l=1;l<=n_comp;l++) a[l][l]=p[l];

	/*
	for (k=1;k<=m;k++) {
		for (l=1;l<=m;l++) {
			a[k][l]= a[l][k];
		}
	}*/

	for (k=1;k<=n_comp;k++) {
		for (l=1;l<=n_comp;l++) {
			if (l > k) {
				a[k][l]=0.0;
			}
		}
	}

	/*for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n_comp; j++) {
			printf("%f\t",a[i][j]);
		}
		printf("\n");
	}*/


	// Calcolo degli urti et = (Sigma)^(1/2)*at
	for(i=1; i<=n_comp; i++) {
		for(j=1; j<=n; j++) {
			sum =0.0;
			for(k=1; k<=n_comp; k++) sum = sum + a[i][k]*x[k][j];
			y[i][j]=sum;
		}
	}

	/*
	for(i=1; i<=n; i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(outfp1,"%f\t",x[j][i]);
		}
		fprintf(outfp1,"\n");
	}*/


	
	for(i=1; i<=n; i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(outfp2,"%f\t",y[j][i]);
		}
		fprintf(outfp2,"\n");
	}


	//verifica
	// Calcolo delle medie
	for(j=1; j<=n_comp; j++) {
		sum =0.0;
		for(h=1; h<=n; h++) sum = sum + y[j][h];
		medie[j] = sum/(double)n;
		//printf("medie[%d] =%.15f\n", j,medie[j]);
	}


	for(j=1; j<=n_comp; j++) {
		for(i=1; i<=n_comp; i++) {
			sum =0;
			for(h=1; h<=n; h++) {
				sum = sum + (y[j][h]-medie[j])*(y[i][h]-medie[i]);
			}
			Sigma[j][i]=sum/(double)n;
			//printf("sigma[%d][%d] =%.10f\n", j,i,Sigma[j][i]);
		}
	}

	int n_oss_1=0, n_oss_2=0, n_oss_3=0, n_oss_4=0;
	
	for(t=order_Var+1; t<=n_oss;t++){

		for(j=1; j<=n_comp; j++) {


				t_d= t-lag_d;
				
				if((sim_Var[t_d][which_serie_1] > R[0]) && (sim_Var[t_d][which_serie_2] <= R[1]) ) { // condizione primo regime	
					
					//fprintf(priserPtr,"Xt-d:%f\n", sim_Var[t_d][which_serie_1]);
					ii=1;
					n_oss_1++;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					sum =0.0;
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);
										

				} // chiusura condizione I regime


				if((sim_Var[t_d][which_serie_1] > R[0]) && (sim_Var[t_d][which_serie_2] > R[1])) { // condizione secondo regime
					sum =0;
					ii=2;
					n_oss_2++;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione II regime


				if((sim_Var[t_d][which_serie_1] <= R[0]) && (sim_Var[t_d][which_serie_2] <= R[1])) { // condizione terzo regime
					sum =0;
					ii=3;
					n_oss_3++;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione III regime


				if((sim_Var[t_d][which_serie_1] <= R[0]) && (sim_Var[t_d][which_serie_2] > R[1])) { // condizione quarto regime
					sum =0.0;
					ii=4;
					n_oss_4++;
					//fprintf(priserPtr,"Regime:%d\n", ii);
					for(h=1; h<=order_Var; h++) {
						for(k=1;k<=n_comp; k++) {
							jj = 1+(h-1)*(n_comp*n_comp) +(k-1)*n_comp+(j-1);
							//fprintf(cfPtr, "j=%d i=%d h=%d  k=%d  jj = %d\n", j, i, h, k, jj);
							sum = sum + AA[jj][ii]*sim_Var[t-h][k];
						}
					}
					//fprintf(priserPtr,"Sum=%f    urto=%f\n", sum, y[j][t]);
					sim_Var[t][j]=sum + y[j][t];
					//fprintf(priserPtr,"Sim_VAr[%d][%d]=%f\n", t,j, sim_Var[t][j]);

				} // chiusura condizione III regime

				
				
			} // chiusura loop n_oss
	} // chiusura loop n_comp

	fprintf(priserPtr,"n_oss_1=%d  n_oss_2=%d   n_oss_3 =%d  n_oss_4=%d\n", n_oss_1, n_oss_2, n_oss_3, n_oss_4);


	int number_delete=100;
	fprintf(priserPtr, "Serie: %d\n", number_rep);
	for(i=1; i<=(n_oss_tot-2*number_delete); i++) {
		for(j=1; j<=n_comp; j++) {
			fprintf(priserPtr,"%f\t",sim_Var[number_delete+i][j]);
		}
		fprintf(priserPtr,"\n");
	}


	// Liberiamo la memoria allocata
	free_matrix(x,1,n_comp,1,n);
	free_matrix(a,1,n_comp,1,n_comp);
	free_vector(p,1,n_comp);
	free_matrix(y,1,n_comp,1,n);
	free_vector(medie,1,n_comp);
	free_matrix(Sigma,1,n_comp,1,n_comp);
	free_dmatrix(AA,1,n_par,1,4);

	//fclose(outfp2);
	fclose(fp);
	//fclose(outfp1);
	fclose(priserPtr);

	return 0;

}
